#include <stdio.h>
#include <stdlib.h>

short *matrix;

char checkpos(short x, short y, short N)
{
	return !(x < 0 || x >= N || y < 0 || y >= N || matrix[x * N + y]);
}

char backtrack(short x, short y, short n, short N)
{
	short i,xx,yy;
	static short m[][2] = { 1,-2, 2,-1, 2,1, 1,2, -1,2, -2,1, -2,-1, -1,-2 };

	if(n == N * N)
		return 1;
	for(i = 0; i < 8; i++)
		if(checkpos(xx = x + m[i][0], yy = y + m[i][1], N)) {
			matrix[xx * N + yy] = n+1;
			if(backtrack(xx,yy,n+1,N))
				return 1;				
		}
	matrix[x * N + y] = 0;
	return 0; 
}

int main(void)
{
	short x,y,n,N;
	
	printf("\nImmetti dimensione lato (minore di 9, altrimenti la computazione dura ore):\n");
	scanf("%hd",&N);
	if(!(matrix = calloc(N * N, sizeof(short))))
		fprintf(stderr,"Errore di allocazione\n");
	x = y = 0;
	matrix[0] = n = 1;
	if(backtrack(x,y,1,N))
		for(y = 0; y < N; y++) {
			for(x = 0; x < N; x++)
				printf("[%2d]",matrix[x * N + y]);
			putchar('\n');
		}
	else
		printf("Non esiste alcuna soluzione per il quadrato di lato %d.\n",N);
	free(matrix);
}

